'                                                                  
' Copyright  2013 Lidor Systems.
' All Rights Reserved.
'
' This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
' either express or implied.                        
'

Public Class Form1

#Region "Initialization"
    Public Sub New()
        InitializeComponent()

        Me.listView1.AllowSubItemFocus = True
        Me.listView1.LabelEdit = True

        CreateLabelContent()

        InitList()
    End Sub

    Private Sub CreateLabelContent()
        Dim content As [String] = "<div style=""font:Verdana,9,r""><p>   In this sample we will show you how to enable columns to automatically or manually change its width to fit its content.</p><br></br>"
        content += "<p>   By default all columns are not auto-sizable. You need to select a specific column and enable this by checking the 'Enable AutoSizable' check box. Then if you select and click on some subitem, a label edit will pop-up where you can change the subitem text. By pressing ENTER, you will notice that the column will automatically change its width.</p><br></br>"
        content += "<p>   In second example, first make sure the 'Label Edit' check box is unchecked. This will prevent interfering with first example. You can manually change the column width, by changing the subitem text from control panel on right, and by pressing the 'Manual AutoSize' button, the column will auto-size its width.</p><br></br>"
        content += "<p>   Finally, if you double-click on column header right, a few pixels from header right line, the column with auto-size its width.</p><br></br>"
        content += "<p><table width=""100%"" cellpadding=""5""><tr><td width=""100%"" style=""align:middleright;textcolor:DarkRed;hovertextcolor:Red""><a href=""www.lidorsystems.com/support/articles/winforms/listview/"">More Info ...</a></td></tr></table></p>"
        content += "</div>"

        Me.labelInfo.Content = content
    End Sub

    Private Sub labelInfo_ContentObjectClicked(ByVal sender As Object, ByVal e As LidorSystems.IntegralUI.ObjectClickEventArgs) Handles labelInfo.ContentObjectClicked
        If TypeOf e.[Object] Is LinkLabel Then
            System.Diagnostics.Process.Start(TryCast(e.[Object], LinkLabel).Links(0).LinkData.ToString())
        End If
    End Sub

    Private Sub InitList()
        Me.listView1.SuspendUpdate()

        Dim column As LidorSystems.IntegralUI.Lists.ListViewColumn = Nothing
        For j As Integer = 0 To 2
            column = New LidorSystems.IntegralUI.Lists.ListViewColumn("Column " & j.ToString(), "Footer " & j.ToString())
            column.Width = 100

            Me.listView1.Columns.Add(column)
            comboColumns.Items.Add(column.HeaderText)
        Next


        Dim item As LidorSystems.IntegralUI.Lists.ListViewItem = Nothing
        Dim subItem As LidorSystems.IntegralUI.Lists.ListViewSubItem = Nothing

        For i As Integer = 0 To 99
            item = New LidorSystems.IntegralUI.Lists.ListViewItem("Item " & i.ToString())

            For j As Integer = 0 To Me.listView1.Columns.Count - 1
                subItem = New LidorSystems.IntegralUI.Lists.ListViewSubItem("Item" & i.ToString() & j.ToString())
                item.SubItems.Add(subItem)
            Next

            Me.listView1.Items.Add(item)
        Next

        Me.listView1.ResumeUpdate()
    End Sub
#End Region

#Region "Functionality"
    Private Sub cbLabelEdit_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cbLabelEdit.CheckedChanged
        Me.listView1.LabelEdit = cbLabelEdit.Checked
    End Sub

    Private Sub comboColumns_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles comboColumns.SelectedIndexChanged
        Dim colIndex As Integer = comboColumns.SelectedIndex
        If colIndex >= 0 AndAlso colIndex < Me.listView1.Columns.Count Then
            cbAutoSizable.Checked = Me.listView1.Columns(colIndex).AutoSizable
        End If
    End Sub

    Private Sub btnEnableAutoSize_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnEnableAutoSize.Click
        Dim colIndex As Integer = comboColumns.SelectedIndex
        If colIndex >= 0 AndAlso colIndex < Me.listView1.Columns.Count Then
            ' Enable column to automatically change its to fit its content
            Me.listView1.Columns(colIndex).AutoSizable = cbAutoSizable.Checked

            ' Update the control
            Me.listView1.UpdateLayout()
        End If
    End Sub

    Private Sub listView1_AfterSubItemSelect(ByVal sender As Object, ByVal e As LidorSystems.IntegralUI.ObjectEventArgs) Handles listView1.AfterSubItemSelect
        If TypeOf e.[Object] Is LidorSystems.IntegralUI.Lists.ListViewSubItem Then
            Dim subItem As LidorSystems.IntegralUI.Lists.ListViewSubItem = DirectCast(e.[Object], LidorSystems.IntegralUI.Lists.ListViewSubItem)

            tbSubItem.Text = subItem.Text
        End If
    End Sub

    Private Sub btnManualAutoSize_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnManualAutoSize.Click
        If Me.listView1.SelectedSubItem IsNot Nothing Then
            Me.listView1.SelectedSubItem.Text = tbSubItem.Text

            ' Manually auto-size column width to accommodate its content
            Me.listView1.AutoSizeColumn(Me.listView1.SelectedSubItem.Index)
        End If
    End Sub
#End Region

End Class
